input {
    file {
		type => "logType"
		path => ["/Users/danillo.ferraz/Projects/Engineering_Essentials_Week_3/calculator/log/*"]
	}
}

filter {
	multiline {
		pattern => '^(?m)\[%{TIMESTAMP_ISO8601}\] \[%{HOSTNAME}\] \[%{DATA}\] %{LOGLEVEL} '
		negate => true
		what => previous
	}

	grok {
		match => { "message" => "(?m)\[%{TIMESTAMP_ISO8601:timestamp}\] \[%{HOSTNAME:host}\] \[%{DATA:thread}\] %{LOGLEVEL:logLevel} %{DATA:class}@%{DATA:method}:%{DATA:line} \- %{GREEDYDATA:message}"}
	    
		overwrite => [ 
		    "host", 
		    "message" 
	    ]
	    
		add_field => { 
		    "code" => "%{class}@%{method}:%{line}"
	    }
	}

	if "_grokparsefailure" in [tags] {
		grok {
			match => [ 
			    "message", "(?m)\[%{TIMESTAMP_ISO8601:timestamp}\] \[%{HOSTNAME:host}\] \[%{DATA:thread}\] %{LOGLEVEL:logLevel} %{DATA:class}@%{DATA:method}:%{DATA:line} \- (?<message>(.|\r|\n)*)" 
		    ]
			overwrite => [ 
			    "host",
			    "message" 
		    ]
			add_field => { 
			    "code" => "%{class}@%{method}:%{line}"
		    }
		}
	}
	
	date {
		match => [
			"timestamp" , "YYYY-MM-dd HH:mm:ss.SSS"
		]
		target => "@timestamp"
	}
}

output {

    stdout {
        codec => rubydebug
    }

    elasticsearch {
        hosts => ["https://p2p-avenuecode-log.es.eastus2.azure.elastic-cloud.com:9243"]
        user => elastic
        password => HAe0BhBJm8Uw7oV3MnDrDKAG
    }
}